local _, ns = ...

local hook
local _E

local B = Stuffing

local bankUpdate = function(self)
	for bagID = -1, 11 do
		if bagID < 0 or  bagID >=5 then -- Prevents trying to update for bag slots
			for slotID = 1, GetContainerNumSlots(bagID) do
				local slotFrame = _G["TukuiBag_"..bagID.."_"..slotID]
				local slotLink = GetContainerItemLink(bagID,slotID)
				SyLevel:CallFilters('Tukbank', slotFrame, _E and slotLink)
			end
		end
	end	
end

local slotUpdate = function(self,b)
	local bagID, slotID = b.bag,b.slot
	if bagID and bagID < 0 or  bagID >=5 and slotID then -- Prevents trying to update for bag slots
		local slotFrame = _G["TukuiBag_"..bagID.."_"..slotID]
		local slotLink = GetContainerItemLink(bagID,slotID)
		SyLevel:CallFilters('Tukbank', slotFrame, _E and slotLink)
	end
end

local update = function(self)
	bankUpdate(self)
end

local enable = function(self)
	_E = true

	if(not hook) then
		if B then
			hooksecurefunc(B,"BagSlotUpdate", bankUpdate)
			hooksecurefunc(B,"SlotUpdate", slotUpdate)
			hook = true
		end
	end
end

local disable = function(self)
	_E = nil
end

ns.SL_TUK.Tukbank = function()
	SyLevel:RegisterPipe('Tukbank', enable, disable, update, 'Tukui Bank Window', nil)
end
