local _, ns = ...
local SL_TUK = ns.SL_TUK

local f = CreateFrame'frame'
f:RegisterEvent("ADDON_LOADED")

function f:UpdatePipeStates()
	for k, v in pairs(SyLevelDB.EnabledPipes) do
		if v then
			SyLevel:EnablePipe(k)
		end
		for filter, enabledPipes in next, SyLevelDB.EnabledFilters do
			if (enabledPipes[k]) then
				SyLevel:RegisterFilterOnPipe(k, filter)
				break
			end
		end
	end
end

function f:CreatePipes()
	if not SyLevel_TukuiDB then SyLevel_TukuiDB = {} end
	local pipes = {
		"Tukbags",
		"Tukbank"
		--"Tukgbank"
	}
	local filter = "Item level text"
	for i=1,#pipes do
		SL_TUK[pipes[i]]() -- Registers pipes
		if not SyLevel_TukuiDB.initialized then			
			SyLevel:EnablePipe(pipes[i]) -- Automatically Sets the SyLevelDB value for us
			SyLevelDB.EnabledFilters[filter][pipes[i]] = true -- Enable the filter for SyLevelDB
		end
	end
	SyLevel_TukuiDB.initialized = true
	self:UpdatePipeStates()
end


f:SetScript("OnEvent", function(self,event,arg1)
	if arg1 == "SyLevel_Tukui" then
		self:UnregisterEvent(event)
		-- Here we're determining if the bag module is enabled within Tukui
		if TukuiConfigPublic then 
			if TukuiConfigPublic["bags"] and TukuiConfigPublic["bags"]["enable"] == false then 
				return -- Since it is not enabled we stop the function
			end 
		end
		self:CreatePipes()	
	end	
end)